# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`openondemand`](#openondemand): Manage Open OnDemand

#### Private Classes

* `openondemand::apache`: Manage Open OnDemand Apache
* `openondemand::config`: Manage Open OnDemand configs
* `openondemand::install`: Manage Open OnDemand install
* `openondemand::repo`: Manage Open OnDemand repos
* `openondemand::service`: Manage Open OnDemand service

### Defined types

* [`openondemand::app::dev`](#openondemandappdev): Manage Open OnDemand dev app
* [`openondemand::app::usr`](#openondemandappusr): Manage Open OnDemand user app
* [`openondemand::cluster`](#openondemandcluster): Manage Open OnDemand cluster definition
* [`openondemand::conf`](#openondemandconf): Manage Open OnDemand configuration file in /etc/ood/config/ondemand.d
* [`openondemand::install::app`](#openondemandinstallapp): Manage Open OnDemand app

### Data types

* [`Openondemand::Acl`](#openondemandacl): OnDemand cluster ACL
* [`Openondemand::Batch_connect`](#openondemandbatch_connect): Defines cluster config batch_connect values
* [`Openondemand::Dashboard_layout`](#openondemanddashboard_layout): Dashboard layout
* [`Openondemand::Dashboard_layout_column`](#openondemanddashboard_layout_column): Dashboard layout column
* [`Openondemand::Dex_config`](#openondemanddex_config): ondemand-dex config
* [`Openondemand::K8_auth`](#openondemandk8_auth): OnDemand cluster Kubernetes auth
* [`Openondemand::K8_mount`](#openondemandk8_mount): OnDemand cluster Kubernetes mount
* [`Openondemand::K8_server`](#openondemandk8_server): OnDemand cluster Kubernetes mount
* [`Openondemand::Nginx_stage_namespace_config`](#openondemandnginx_stage_namespace_config): nginx_stage.yml namespace_config

### Tasks

* [`announce`](#announce): Install Open OnDemand announcement file
* [`maintenance`](#maintenance): Put OnDemand into maintenance mode
* [`nginx_stage`](#nginx_stage): Run nginx_stage commands

## Classes

### <a name="openondemand"></a>`openondemand`

Manage Open OnDemand

#### Parameters

The following parameters are available in the `openondemand` class:

* [`repo_release`](#repo_release)
* [`repo_baseurl_prefix`](#repo_baseurl_prefix)
* [`repo_gpgkey`](#repo_gpgkey)
* [`repo_priority`](#repo_priority)
* [`manage_dependency_repos`](#manage_dependency_repos)
* [`repo_nightly`](#repo_nightly)
* [`selinux`](#selinux)
* [`ondemand_package_ensure`](#ondemand_package_ensure)
* [`ondemand_dex_package_ensure`](#ondemand_dex_package_ensure)
* [`mod_auth_openidc_ensure`](#mod_auth_openidc_ensure)
* [`install_apps`](#install_apps)
* [`declare_apache`](#declare_apache)
* [`apache_scls`](#apache_scls)
* [`listen_addr_port`](#listen_addr_port)
* [`servername`](#servername)
* [`ssl`](#ssl)
* [`logroot`](#logroot)
* [`use_rewrites`](#use_rewrites)
* [`use_maintenance`](#use_maintenance)
* [`maintenance_ip_whitelist`](#maintenance_ip_whitelist)
* [`maintenance_source`](#maintenance_source)
* [`maintenance_content`](#maintenance_content)
* [`security_csp_frame_ancestors`](#security_csp_frame_ancestors)
* [`security_strict_transport`](#security_strict_transport)
* [`lua_root`](#lua_root)
* [`lua_log_level`](#lua_log_level)
* [`user_map_match`](#user_map_match)
* [`user_map_cmd`](#user_map_cmd)
* [`user_env`](#user_env)
* [`map_fail_uri`](#map_fail_uri)
* [`auth_type`](#auth_type)
* [`auth_configs`](#auth_configs)
* [`root_uri`](#root_uri)
* [`analytics`](#analytics)
* [`public_uri`](#public_uri)
* [`public_root`](#public_root)
* [`logout_uri`](#logout_uri)
* [`logout_redirect`](#logout_redirect)
* [`host_regex`](#host_regex)
* [`node_uri`](#node_uri)
* [`rnode_uri`](#rnode_uri)
* [`nginx_uri`](#nginx_uri)
* [`pun_uri`](#pun_uri)
* [`pun_socket_root`](#pun_socket_root)
* [`pun_max_retries`](#pun_max_retries)
* [`pun_pre_hook_root_cmd`](#pun_pre_hook_root_cmd)
* [`pun_pre_hook_exports`](#pun_pre_hook_exports)
* [`oidc_uri`](#oidc_uri)
* [`oidc_discover_uri`](#oidc_discover_uri)
* [`oidc_discover_root`](#oidc_discover_root)
* [`register_uri`](#register_uri)
* [`register_root`](#register_root)
* [`oidc_provider_metadata_url`](#oidc_provider_metadata_url)
* [`oidc_client_id`](#oidc_client_id)
* [`oidc_client_secret`](#oidc_client_secret)
* [`oidc_remote_user_claim`](#oidc_remote_user_claim)
* [`oidc_scope`](#oidc_scope)
* [`oidc_session_inactivity_timeout`](#oidc_session_inactivity_timeout)
* [`oidc_session_max_duration`](#oidc_session_max_duration)
* [`oidc_state_max_number_of_cookies`](#oidc_state_max_number_of_cookies)
* [`oidc_settings`](#oidc_settings)
* [`dex_config`](#dex_config)
* [`web_directory`](#web_directory)
* [`nginx_log_group`](#nginx_log_group)
* [`nginx_stage_clean_cron_schedule`](#nginx_stage_clean_cron_schedule)
* [`nginx_stage_ondemand_portal`](#nginx_stage_ondemand_portal)
* [`nginx_stage_ondemand_title`](#nginx_stage_ondemand_title)
* [`nginx_stage_pun_custom_env`](#nginx_stage_pun_custom_env)
* [`nginx_stage_app_root`](#nginx_stage_app_root)
* [`nginx_stage_scl_env`](#nginx_stage_scl_env)
* [`nginx_stage_app_request_regex`](#nginx_stage_app_request_regex)
* [`nginx_stage_min_uid`](#nginx_stage_min_uid)
* [`nginx_stage_passenger_pool_idle_time`](#nginx_stage_passenger_pool_idle_time)
* [`nginx_stage_passenger_options`](#nginx_stage_passenger_options)
* [`nginx_stage_nginx_file_upload_max`](#nginx_stage_nginx_file_upload_max)
* [`nginx_stage_configs`](#nginx_stage_configs)
* [`config_dir_purge`](#config_dir_purge)
* [`config_source`](#config_source)
* [`config_content`](#config_content)
* [`confs`](#confs)
* [`pinned_apps`](#pinned_apps)
* [`pinned_apps_menu_length`](#pinned_apps_menu_length)
* [`pinned_apps_group_by`](#pinned_apps_group_by)
* [`dashboard_layout`](#dashboard_layout)
* [`hook_env`](#hook_env)
* [`hook_env_path`](#hook_env_path)
* [`hook_env_config`](#hook_env_config)
* [`kubectl_path`](#kubectl_path)
* [`clusters`](#clusters)
* [`clusters_hiera_merge`](#clusters_hiera_merge)
* [`usr_apps`](#usr_apps)
* [`usr_app_defaults`](#usr_app_defaults)
* [`dev_apps`](#dev_apps)
* [`dev_app_users`](#dev_app_users)
* [`dev_app_defaults`](#dev_app_defaults)
* [`apps_config_repo`](#apps_config_repo)
* [`apps_config_revision`](#apps_config_revision)
* [`apps_config_repo_path`](#apps_config_repo_path)
* [`locales_config_repo_path`](#locales_config_repo_path)
* [`announcements_config_repo_path`](#announcements_config_repo_path)
* [`apps_config_source`](#apps_config_source)
* [`locales_config_source`](#locales_config_source)
* [`announcements_config_source`](#announcements_config_source)
* [`public_files_repo_paths`](#public_files_repo_paths)
* [`manage_logrotate`](#manage_logrotate)

##### <a name="repo_release"></a>`repo_release`

Data type: `String`

The release of OnDemand repo

Default value: `'latest'`

##### <a name="repo_baseurl_prefix"></a>`repo_baseurl_prefix`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl]`

The baseurl prefix for OnDemand repo

Default value: `'https://yum.osc.edu/ondemand'`

##### <a name="repo_gpgkey"></a>`repo_gpgkey`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl, Stdlib::Absolutepath]`

The URL for OnDemand repo GPG key

Default value: `'https://yum.osc.edu/ondemand/RPM-GPG-KEY-ondemand'`

##### <a name="repo_priority"></a>`repo_priority`

Data type: `Integer[1,99]`

The priority of the OnDemand repo

Default value: `99`

##### <a name="manage_dependency_repos"></a>`manage_dependency_repos`

Data type: `Boolean`

Boolean that determines if managing repos for package dependencies

Default value: ``true``

##### <a name="repo_nightly"></a>`repo_nightly`

Data type: `Boolean`

Add the OnDemand nightly repo

Default value: ``false``

##### <a name="selinux"></a>`selinux`

Data type: `Boolean`

Boolean that determines if adding SELinux support

Default value: ``false``

##### <a name="ondemand_package_ensure"></a>`ondemand_package_ensure`

Data type: `String`

ondemand package ensure

Default value: `'present'`

##### <a name="ondemand_dex_package_ensure"></a>`ondemand_dex_package_ensure`

Data type: `String`

ondemand-dex package ensure

Default value: `'present'`

##### <a name="mod_auth_openidc_ensure"></a>`mod_auth_openidc_ensure`

Data type: `String`

mod_auth_openidc package ensure

Default value: `'present'`

##### <a name="install_apps"></a>`install_apps`

Data type: `Hash`

Hash of apps to install, passed to ondemand::install::app

Default value: `{}`

##### <a name="declare_apache"></a>`declare_apache`

Data type: `Boolean`

Boolean that determines if apache is declared or included

Default value: ``true``

##### <a name="apache_scls"></a>`apache_scls`

Data type: `String`

SCLs to load when starting Apache service

Default value: `'httpd24'`

##### <a name="listen_addr_port"></a>`listen_addr_port`

Data type: `Variant[Array, String, Undef]`

ood_portal.yml listen_addr_port

Default value: ``undef``

##### <a name="servername"></a>`servername`

Data type: `Optional[String]`

ood_portal.yml servername

Default value: ``undef``

##### <a name="ssl"></a>`ssl`

Data type: `Optional[Array]`

ood_portal.yml ssl

Default value: ``undef``

##### <a name="logroot"></a>`logroot`

Data type: `String`

ood_portal.yml logroot

Default value: `'logs'`

##### <a name="use_rewrites"></a>`use_rewrites`

Data type: `Boolean`

ood_portal.yml use_rewrites

Default value: ``true``

##### <a name="use_maintenance"></a>`use_maintenance`

Data type: `Boolean`

ood_portal.yml use_maintenance

Default value: ``true``

##### <a name="maintenance_ip_whitelist"></a>`maintenance_ip_whitelist`

Data type: `Array`

ood_portal.yml maintenance_ip_whitelist

Default value: `[]`

##### <a name="maintenance_source"></a>`maintenance_source`

Data type: `Optional[String]`

Source for maintenance index.html

Default value: ``undef``

##### <a name="maintenance_content"></a>`maintenance_content`

Data type: `Optional[String]`

Content for maintenance index.html

Default value: ``undef``

##### <a name="security_csp_frame_ancestors"></a>`security_csp_frame_ancestors`

Data type: `Optional[Variant[String, Boolean]]`

ood_portal.yml security_csp_frame_ancestors

Default value: ``undef``

##### <a name="security_strict_transport"></a>`security_strict_transport`

Data type: `Boolean`

ood_portal.yml security_strict_transport

Default value: ``true``

##### <a name="lua_root"></a>`lua_root`

Data type: `String`

ood_portal.yml lua_root

Default value: `'/opt/ood/mod_ood_proxy/lib'`

##### <a name="lua_log_level"></a>`lua_log_level`

Data type: `Optional[String]`

ood_portal.yml lua_log_level

Default value: ``undef``

##### <a name="user_map_match"></a>`user_map_match`

Data type: `String`

ood_portal.yml user_map_match

Default value: `'.*'`

##### <a name="user_map_cmd"></a>`user_map_cmd`

Data type: `Optional[String]`

ood_portal.yml user_map_cmd

Default value: ``undef``

##### <a name="user_env"></a>`user_env`

Data type: `Optional[String]`

ood_portal.yml user_env

Default value: ``undef``

##### <a name="map_fail_uri"></a>`map_fail_uri`

Data type: `Optional[String]`

ood_portal.yml map_fail_uri

Default value: ``undef``

##### <a name="auth_type"></a>`auth_type`

Data type: `Enum['CAS', 'openid-connect', 'shibboleth', 'dex']`

ood_portal.yml auth_type

Default value: `'dex'`

##### <a name="auth_configs"></a>`auth_configs`

Data type: `Optional[Array]`

ood_portal.yml auth_configs

Default value: ``undef``

##### <a name="root_uri"></a>`root_uri`

Data type: `String`

ood_portal.yml root_uri

Default value: `'/pun/sys/dashboard'`

##### <a name="analytics"></a>`analytics`

Data type: `Optional[Struct[{url => String, id => String}]]`

ood_portal.yml analytics

Default value: ``undef``

##### <a name="public_uri"></a>`public_uri`

Data type: `String`

ood_portal.yml public_uri

Default value: `'/public'`

##### <a name="public_root"></a>`public_root`

Data type: `String`

ood_portal.yml public_root

Default value: `'/var/www/ood/public'`

##### <a name="logout_uri"></a>`logout_uri`

Data type: `String`

ood_portal.yml logout_uri

Default value: `'/logout'`

##### <a name="logout_redirect"></a>`logout_redirect`

Data type: `String`

ood_portal.yml logout_redirect

Default value: `'/pun/sys/dashboard/logout'`

##### <a name="host_regex"></a>`host_regex`

Data type: `String`

ood_portal.yml host_regex

Default value: `'[^/]+'`

##### <a name="node_uri"></a>`node_uri`

Data type: `Optional[String]`

ood_portal.yml node_uri

Default value: ``undef``

##### <a name="rnode_uri"></a>`rnode_uri`

Data type: `Optional[String]`

ood_portal.yml rnode_uri

Default value: ``undef``

##### <a name="nginx_uri"></a>`nginx_uri`

Data type: `String`

ood_portal.yml nginx_uri

Default value: `'/nginx'`

##### <a name="pun_uri"></a>`pun_uri`

Data type: `String`

ood_portal.yml pun_uri

Default value: `'/pun'`

##### <a name="pun_socket_root"></a>`pun_socket_root`

Data type: `String`

ood_portal.yml pun_socket_root

Default value: `'/var/run/ondemand-nginx'`

##### <a name="pun_max_retries"></a>`pun_max_retries`

Data type: `Integer`

ood_portal.yml pun_max_retries

Default value: `5`

##### <a name="pun_pre_hook_root_cmd"></a>`pun_pre_hook_root_cmd`

Data type: `Optional[Stdlib::Absolutepath]`

ood_portal.yml pun_pre_hook_root_cmd

Default value: ``undef``

##### <a name="pun_pre_hook_exports"></a>`pun_pre_hook_exports`

Data type: `Optional[String]`

ood_porta.yml pun_pre_hook_exports

Default value: ``undef``

##### <a name="oidc_uri"></a>`oidc_uri`

Data type: `Optional[String]`

ood_portal.yml oidc_uri

Default value: ``undef``

##### <a name="oidc_discover_uri"></a>`oidc_discover_uri`

Data type: `Optional[String]`

ood_portal.yml oidc_discover_uri

Default value: ``undef``

##### <a name="oidc_discover_root"></a>`oidc_discover_root`

Data type: `Optional[String]`

ood_portal.yml oidc_discover_root

Default value: ``undef``

##### <a name="register_uri"></a>`register_uri`

Data type: `Optional[String]`

ood_portal.yml register_uri

Default value: ``undef``

##### <a name="register_root"></a>`register_root`

Data type: `Optional[String]`

ood_portal.yml register_root

Default value: ``undef``

##### <a name="oidc_provider_metadata_url"></a>`oidc_provider_metadata_url`

Data type: `Optional[String]`

OIDC metadata URL

Default value: ``undef``

##### <a name="oidc_client_id"></a>`oidc_client_id`

Data type: `Optional[String]`

OIDC client ID

Default value: ``undef``

##### <a name="oidc_client_secret"></a>`oidc_client_secret`

Data type: `Optional[String]`

OIDC client secret

Default value: ``undef``

##### <a name="oidc_remote_user_claim"></a>`oidc_remote_user_claim`

Data type: `String`

OIDC REMOTE_USER claim

Default value: `'preferred_username'`

##### <a name="oidc_scope"></a>`oidc_scope`

Data type: `String`

OIDC scopes

Default value: `'openid profile email'`

##### <a name="oidc_session_inactivity_timeout"></a>`oidc_session_inactivity_timeout`

Data type: `Integer`

OIDC session inactivity timeout, see OIDCSessionInactivityTimeout

Default value: `28800`

##### <a name="oidc_session_max_duration"></a>`oidc_session_max_duration`

Data type: `Integer`

OIDC session max duration, see OIDCSessionMaxDuration

Default value: `28800`

##### <a name="oidc_state_max_number_of_cookies"></a>`oidc_state_max_number_of_cookies`

Data type: `String`

OIDC setting that determines how to clean up cookies

Default value: `'10 true'`

##### <a name="oidc_settings"></a>`oidc_settings`

Data type: `Hash`

Hash of OIDC settings passsed directly to Apache config

Default value: `{}`

##### <a name="dex_config"></a>`dex_config`

Data type: `Openondemand::Dex_config`

Dex configuration Hash

Default value: `{}`

##### <a name="web_directory"></a>`web_directory`

Data type: `Stdlib::Absolutepath`

Path to main web directory for OnDemand

Default value: `'/var/www/ood'`

##### <a name="nginx_log_group"></a>`nginx_log_group`

Data type: `String`

Group to set for /var/log/ondemand-nginx

Default value: `'ondemand-nginx'`

##### <a name="nginx_stage_clean_cron_schedule"></a>`nginx_stage_clean_cron_schedule`

Data type: `String`

Configure how often you want to run nginx_clean
Defaults to '0 */2 * * *' (every other hour)

Default value: `'0 */2 * * *'`

##### <a name="nginx_stage_ondemand_portal"></a>`nginx_stage_ondemand_portal`

Data type: `String`

nginx_stage.yml ondemand_portal

Default value: `'ondemand'`

##### <a name="nginx_stage_ondemand_title"></a>`nginx_stage_ondemand_title`

Data type: `String`

nginx_stage.yml ondemand_title

Default value: `'Open OnDemand'`

##### <a name="nginx_stage_pun_custom_env"></a>`nginx_stage_pun_custom_env`

Data type: `Hash`

nginx_stage.yml pun_custom_env

Default value: `{}`

##### <a name="nginx_stage_app_root"></a>`nginx_stage_app_root`

Data type: `Openondemand::Nginx_stage_namespace_config`

nginx_stage.yml app_root

Default value: `{}`

##### <a name="nginx_stage_scl_env"></a>`nginx_stage_scl_env`

Data type: `String`

nginx_stage.yml scl_env

Default value: `'ondemand'`

##### <a name="nginx_stage_app_request_regex"></a>`nginx_stage_app_request_regex`

Data type: `Optional[Openondemand::Nginx_stage_namespace_config]`

nginx_stage.yml app_request_regex

Default value: ``undef``

##### <a name="nginx_stage_min_uid"></a>`nginx_stage_min_uid`

Data type: `Integer`

nginx_stage.yml min_uid

Default value: `1000`

##### <a name="nginx_stage_passenger_pool_idle_time"></a>`nginx_stage_passenger_pool_idle_time`

Data type: `Integer`

nginx_stage.yml passenger_pool_idle_time

Default value: `300`

##### <a name="nginx_stage_passenger_options"></a>`nginx_stage_passenger_options`

Data type: `Hash[Pattern[/^passenger_.+/], Variant[String, Integer]]`

nginx_stage.yml passenger_options

Default value: `{}`

##### <a name="nginx_stage_nginx_file_upload_max"></a>`nginx_stage_nginx_file_upload_max`

Data type: `Optional[Integer]`

nginx_stage.yml nginx_file_upload_max

Default value: ``undef``

##### <a name="nginx_stage_configs"></a>`nginx_stage_configs`

Data type: `Hash`

nginx_stage.yml extra configuration options

Default value: `{}`

##### <a name="config_dir_purge"></a>`config_dir_purge`

Data type: `Boolean`

Boolean that sets if ondemand.d should be purged of unmanaged files

Default value: ``true``

##### <a name="config_source"></a>`config_source`

Data type: `Optional[String]`

The source for /etc/ood/config/ondemand.d/ondemand.yml
Overrides `config_content` as well as pinned apps and dashboard layout parameters

Default value: ``undef``

##### <a name="config_content"></a>`config_content`

Data type: `Optional[String]`

The content for /etc/ood/config/ondemand.d/ondemand.yml
Overrides pinned apps and dashboard layout parameters

Default value: ``undef``

##### <a name="confs"></a>`confs`

Data type: `Hash`

Hash to define openondemand::conf resources

Default value: `{}`

##### <a name="pinned_apps"></a>`pinned_apps`

Data type: `Optional[Array[Variant[String[1], Hash]]]`

Defines the OnDemand configuration for pinned_apps

Default value: ``undef``

##### <a name="pinned_apps_menu_length"></a>`pinned_apps_menu_length`

Data type: `Optional[Integer]`

Defines the OnDemand configuration for pinned_apps_menu_length

Default value: ``undef``

##### <a name="pinned_apps_group_by"></a>`pinned_apps_group_by`

Data type: `Optional[String[1]]`

Defines the OnDemand configuration for pinned_apps_group_by

Default value: ``undef``

##### <a name="dashboard_layout"></a>`dashboard_layout`

Data type: `Optional[Openondemand::Dashboard_layout]`

Defines the OnDemand configuration for dashboard_layout

Default value: ``undef``

##### <a name="hook_env"></a>`hook_env`

Data type: `Boolean`

Boolean that sets of hook.env configuration should be managed

Default value: ``true``

##### <a name="hook_env_path"></a>`hook_env_path`

Data type: `Stdlib::Absolutepath`

Path to hook.env

Default value: `'/etc/ood/config/hook.env'`

##### <a name="hook_env_config"></a>`hook_env_config`

Data type: `Hash`

Configuration hash to pass into hook.env

Default value: `{}`

##### <a name="kubectl_path"></a>`kubectl_path`

Data type: `Stdlib::Absolutepath`

Path to kubectl

Default value: `'/bin/kubectl'`

##### <a name="clusters"></a>`clusters`

Data type: `Hash`

Hash of resources to apss to openondemand::cluster

Default value: `{}`

##### <a name="clusters_hiera_merge"></a>`clusters_hiera_merge`

Data type: `Boolean`

Boolean that determines if clusters should be merged via lookup function

Default value: ``true``

##### <a name="usr_apps"></a>`usr_apps`

Data type: `Variant[Array, Hash]`

Resources passed to openondemand::app::usr

Default value: `{}`

##### <a name="usr_app_defaults"></a>`usr_app_defaults`

Data type: `Hash`

Defaults for `usr_apps` resources

Default value: `{}`

##### <a name="dev_apps"></a>`dev_apps`

Data type: `Hash`

Resources passed to openondemand::app::dev

Default value: `{}`

##### <a name="dev_app_users"></a>`dev_app_users`

Data type: `Array`

Users to define as having dev apps, passed to openondemand::app::dev

Default value: `[]`

##### <a name="dev_app_defaults"></a>`dev_app_defaults`

Data type: `Hash`

Defaults for `dev_apps` and `dev_app_users`

Default value: `{}`

##### <a name="apps_config_repo"></a>`apps_config_repo`

Data type: `Optional[String]`

Git repo URL for apps config

Default value: ``undef``

##### <a name="apps_config_revision"></a>`apps_config_revision`

Data type: `Optional[String]`

Revision for apps config Git repo

Default value: ``undef``

##### <a name="apps_config_repo_path"></a>`apps_config_repo_path`

Data type: `String`

Path in apps config Git repo for app configs

Default value: `''`

##### <a name="locales_config_repo_path"></a>`locales_config_repo_path`

Data type: `Optional[String]`

Path in apps config Git repo for locales configs

Default value: ``undef``

##### <a name="announcements_config_repo_path"></a>`announcements_config_repo_path`

Data type: `Optional[String]`

Path in apps config Git repo for announcements

Default value: ``undef``

##### <a name="apps_config_source"></a>`apps_config_source`

Data type: `Optional[String]`

Source for apps config, not used if `apps_config_repo` is defined

Default value: ``undef``

##### <a name="locales_config_source"></a>`locales_config_source`

Data type: `Optional[String]`

Source for locales config, not used if `apps_config_repo` is defined

Default value: ``undef``

##### <a name="announcements_config_source"></a>`announcements_config_source`

Data type: `Optional[String]`

Source for aouncements config, not used if `apps_config_repo` is defined

Default value: ``undef``

##### <a name="public_files_repo_paths"></a>`public_files_repo_paths`

Data type: `Array`

Path to public files in apps config Git repo

Default value: `[]`

##### <a name="manage_logrotate"></a>`manage_logrotate`

Data type: `Boolean`

Boolean that allows disabling management of logrotate

Default value: ``true``

## Defined types

### <a name="openondemandappdev"></a>`openondemand::app::dev`

Manage Open OnDemand dev app

#### Examples

##### 

```puppet
openondemand::app::dev { 'user1': }
```

#### Parameters

The following parameters are available in the `openondemand::app::dev` defined type:

* [`ensure`](#ensure)
* [`mode`](#mode)
* [`owner`](#owner)
* [`group`](#group)
* [`home_subdir`](#home_subdir)
* [`gateway_src`](#gateway_src)

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`



Default value: `'present'`

##### <a name="mode"></a>`mode`

Data type: `Stdlib::Filemode`

File mode of dev app

Default value: `'0755'`

##### <a name="owner"></a>`owner`

Data type: `String`

Owner of dev app

Default value: `'root'`

##### <a name="group"></a>`group`

Data type: `String`

Group owning dev app

Default value: `'root'`

##### <a name="home_subdir"></a>`home_subdir`

Data type: `String`

The subdirectory under user's home for dev app
Not used if `gateway_src` is defined

Default value: `'ondemand/dev'`

##### <a name="gateway_src"></a>`gateway_src`

Data type: `Optional[Stdlib::Absolutepath]`

The path to dev app, overrides `home_subdir`

Default value: ``undef``

### <a name="openondemandappusr"></a>`openondemand::app::usr`

Manage Open OnDemand user app

#### Examples

##### 

```puppet
openondemand::app::usr { 'user1':
  gateway_src => '/home/user1/ondemand/usr',
}
```

#### Parameters

The following parameters are available in the `openondemand::app::usr` defined type:

* [`gateway_src`](#gateway_src)
* [`ensure`](#ensure)
* [`mode`](#mode)
* [`owner`](#owner)
* [`group`](#group)

##### <a name="gateway_src"></a>`gateway_src`

Data type: `Stdlib::Absolutepath`

Path to source of user's apps

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present','absent']`



Default value: `'present'`

##### <a name="mode"></a>`mode`

Data type: `Stdlib::Filemode`

The file mode for shared apps

Default value: `'0750'`

##### <a name="owner"></a>`owner`

Data type: `String`

The file owner of shared apps

Default value: `'root'`

##### <a name="group"></a>`group`

Data type: `String`

The file group owner of shared apps

Default value: `'root'`

### <a name="openondemandcluster"></a>`openondemand::cluster`

Manage Open OnDemand cluster definition

#### Parameters

The following parameters are available in the `openondemand::cluster` defined type:

* [`cluster_title`](#cluster_title)
* [`url`](#url)
* [`hidden`](#hidden)
* [`acls`](#acls)
* [`login_host`](#login_host)
* [`job_adapter`](#job_adapter)
* [`job_cluster`](#job_cluster)
* [`job_host`](#job_host)
* [`job_lib`](#job_lib)
* [`job_libdir`](#job_libdir)
* [`job_bin`](#job_bin)
* [`job_bindir`](#job_bindir)
* [`job_conf`](#job_conf)
* [`job_envdir`](#job_envdir)
* [`job_serverdir`](#job_serverdir)
* [`job_exec`](#job_exec)
* [`sge_root`](#sge_root)
* [`libdrmaa_path`](#libdrmaa_path)
* [`job_version`](#job_version)
* [`job_bin_overrides`](#job_bin_overrides)
* [`job_submit_host`](#job_submit_host)
* [`job_ssh_hosts`](#job_ssh_hosts)
* [`job_site_timeout`](#job_site_timeout)
* [`job_debug`](#job_debug)
* [`job_singularity_bin`](#job_singularity_bin)
* [`job_singularity_bindpath`](#job_singularity_bindpath)
* [`job_singularity_image`](#job_singularity_image)
* [`job_strict_host_checking`](#job_strict_host_checking)
* [`job_tmux_bin`](#job_tmux_bin)
* [`job_config_file`](#job_config_file)
* [`job_username_prefix`](#job_username_prefix)
* [`job_namespace_prefix`](#job_namespace_prefix)
* [`job_all_namespaces`](#job_all_namespaces)
* [`job_auto_supplemental_groups`](#job_auto_supplemental_groups)
* [`job_server`](#job_server)
* [`job_mounts`](#job_mounts)
* [`job_auth`](#job_auth)
* [`scheduler_type`](#scheduler_type)
* [`scheduler_host`](#scheduler_host)
* [`scheduler_bin`](#scheduler_bin)
* [`scheduler_version`](#scheduler_version)
* [`scheduler_params`](#scheduler_params)
* [`rsv_query_acls`](#rsv_query_acls)
* [`ganglia_host`](#ganglia_host)
* [`ganglia_scheme`](#ganglia_scheme)
* [`ganglia_segments`](#ganglia_segments)
* [`ganglia_req_query`](#ganglia_req_query)
* [`ganglia_opt_query`](#ganglia_opt_query)
* [`ganglia_version`](#ganglia_version)
* [`grafana_host`](#grafana_host)
* [`grafana_org_id`](#grafana_org_id)
* [`grafana_theme`](#grafana_theme)
* [`grafana_dashboard_name`](#grafana_dashboard_name)
* [`grafana_dashboard_uid`](#grafana_dashboard_uid)
* [`grafana_dashboard_panels`](#grafana_dashboard_panels)
* [`grafana_labels`](#grafana_labels)
* [`grafana_cluster_override`](#grafana_cluster_override)
* [`xdmod_resource_id`](#xdmod_resource_id)
* [`custom_config`](#custom_config)
* [`batch_connect`](#batch_connect)

##### <a name="cluster_title"></a>`cluster_title`

Data type: `String`



Default value: `$name`

##### <a name="url"></a>`url`

Data type: `Optional[Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl] ]`



Default value: ``undef``

##### <a name="hidden"></a>`hidden`

Data type: `Boolean`



Default value: ``false``

##### <a name="acls"></a>`acls`

Data type: `Array[Openondemand::Acl]`



Default value: `[]`

##### <a name="login_host"></a>`login_host`

Data type: `Optional[Stdlib::Host]`



Default value: ``undef``

##### <a name="job_adapter"></a>`job_adapter`

Data type: `Optional[Enum['torque','slurm','lsf','pbspro','sge','linux_host','kubernetes']]`



Default value: ``undef``

##### <a name="job_cluster"></a>`job_cluster`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="job_host"></a>`job_host`

Data type: `Optional[Stdlib::Host]`



Default value: ``undef``

##### <a name="job_lib"></a>`job_lib`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_libdir"></a>`job_libdir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_bin"></a>`job_bin`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_bindir"></a>`job_bindir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_conf"></a>`job_conf`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_envdir"></a>`job_envdir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_serverdir"></a>`job_serverdir`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_exec"></a>`job_exec`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="sge_root"></a>`sge_root`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="libdrmaa_path"></a>`libdrmaa_path`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_version"></a>`job_version`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="job_bin_overrides"></a>`job_bin_overrides`

Data type: `Hash[String, Stdlib::Absolutepath]`



Default value: `{}`

##### <a name="job_submit_host"></a>`job_submit_host`

Data type: `Optional[Stdlib::Host]`



Default value: ``undef``

##### <a name="job_ssh_hosts"></a>`job_ssh_hosts`

Data type: `Array[Stdlib::Host]`



Default value: `[]`

##### <a name="job_site_timeout"></a>`job_site_timeout`

Data type: `Optional[Integer]`



Default value: ``undef``

##### <a name="job_debug"></a>`job_debug`

Data type: `Optional[Boolean]`



Default value: ``undef``

##### <a name="job_singularity_bin"></a>`job_singularity_bin`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_singularity_bindpath"></a>`job_singularity_bindpath`

Data type: `Optional[Variant[Array[Stdlib::Absolutepath], String]]`



Default value: ``undef``

##### <a name="job_singularity_image"></a>`job_singularity_image`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="job_strict_host_checking"></a>`job_strict_host_checking`

Data type: `Optional[Boolean]`



Default value: ``undef``

##### <a name="job_tmux_bin"></a>`job_tmux_bin`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="job_config_file"></a>`job_config_file`

Data type: `Optional[String[1]]`



Default value: ``undef``

##### <a name="job_username_prefix"></a>`job_username_prefix`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="job_namespace_prefix"></a>`job_namespace_prefix`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="job_all_namespaces"></a>`job_all_namespaces`

Data type: `Boolean`



Default value: ``false``

##### <a name="job_auto_supplemental_groups"></a>`job_auto_supplemental_groups`

Data type: `Boolean`



Default value: ``false``

##### <a name="job_server"></a>`job_server`

Data type: `Optional[Openondemand::K8_server]`



Default value: ``undef``

##### <a name="job_mounts"></a>`job_mounts`

Data type: `Array[Openondemand::K8_mount]`



Default value: `[]`

##### <a name="job_auth"></a>`job_auth`

Data type: `Optional[Openondemand::K8_auth]`



Default value: ``undef``

##### <a name="scheduler_type"></a>`scheduler_type`

Data type: `Optional[Enum['moab']]`



Default value: ``undef``

##### <a name="scheduler_host"></a>`scheduler_host`

Data type: `Optional[Stdlib::Host]`



Default value: ``undef``

##### <a name="scheduler_bin"></a>`scheduler_bin`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: ``undef``

##### <a name="scheduler_version"></a>`scheduler_version`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="scheduler_params"></a>`scheduler_params`

Data type: `Hash`



Default value: `{}`

##### <a name="rsv_query_acls"></a>`rsv_query_acls`

Data type: `Array[Openondemand::Acl]`



Default value: `[]`

##### <a name="ganglia_host"></a>`ganglia_host`

Data type: `Optional[Stdlib::Host]`



Default value: ``undef``

##### <a name="ganglia_scheme"></a>`ganglia_scheme`

Data type: `String`



Default value: `'https://'`

##### <a name="ganglia_segments"></a>`ganglia_segments`

Data type: `Array`



Default value: `['gweb', 'graph.php']`

##### <a name="ganglia_req_query"></a>`ganglia_req_query`

Data type: `Hash`



Default value: `{'c' => $name}`

##### <a name="ganglia_opt_query"></a>`ganglia_opt_query`

Data type: `Hash`



Default value: `{'h' => "%{h}.${::domain}"}`

##### <a name="ganglia_version"></a>`ganglia_version`

Data type: `String`



Default value: `'3'`

##### <a name="grafana_host"></a>`grafana_host`

Data type: `Optional[Variant[Stdlib::HTTPSUrl,Stdlib::HTTPUrl]]`



Default value: ``undef``

##### <a name="grafana_org_id"></a>`grafana_org_id`

Data type: `Integer`



Default value: `1`

##### <a name="grafana_theme"></a>`grafana_theme`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="grafana_dashboard_name"></a>`grafana_dashboard_name`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="grafana_dashboard_uid"></a>`grafana_dashboard_uid`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="grafana_dashboard_panels"></a>`grafana_dashboard_panels`

Data type: `Optional[Struct[{
    'cpu' => Integer,
    'memory' => Integer,
  }]]`



Default value: ``undef``

##### <a name="grafana_labels"></a>`grafana_labels`

Data type: `Optional[Struct[{
    'cluster' => String,
    'host' => String,
    'jobid' => Optional[String],
  }]]`



Default value: ``undef``

##### <a name="grafana_cluster_override"></a>`grafana_cluster_override`

Data type: `Optional[String]`



Default value: ``undef``

##### <a name="xdmod_resource_id"></a>`xdmod_resource_id`

Data type: `Optional[Integer]`



Default value: ``undef``

##### <a name="custom_config"></a>`custom_config`

Data type: `Hash`

Custom Hash passed to `v2.custom` in cluster YAML

Default value: `{}`

##### <a name="batch_connect"></a>`batch_connect`

Data type: `Openondemand::Batch_connect`



Default value: `{}`

### <a name="openondemandconf"></a>`openondemand::conf`

Manage Open OnDemand configuration file in /etc/ood/config/ondemand.d

#### Parameters

The following parameters are available in the `openondemand::conf` defined type:

* [`source`](#source)
* [`content`](#content)
* [`content_template`](#content_template)
* [`data`](#data)
* [`template`](#template)
* [`filename`](#filename)

##### <a name="source"></a>`source`

Data type: `Optional[String]`

The source of the configuration file

Default value: ``undef``

##### <a name="content"></a>`content`

Data type: `Optional[String]`

The content template of the configuration file

Default value: ``undef``

##### <a name="content_template"></a>`content_template`

Data type: `Optional[String]`

The template to define content

Default value: ``undef``

##### <a name="data"></a>`data`

Data type: `Optional[Hash]`

A hash of data to convert to YAML that defines the configuration file contents

Default value: ``undef``

##### <a name="template"></a>`template`

Data type: `Boolean`

If true, the file will have .yml.erb extension, otherwise the extension is .yml

Default value: ``false``

##### <a name="filename"></a>`filename`

Data type: `Optional[String]`

Override the default filename for the configuration file

Default value: ``undef``

### <a name="openondemandinstallapp"></a>`openondemand::install::app`

Manage Open OnDemand app

#### Examples

##### 

```puppet
openondemand::install::app { 'bc_osc_foo':
  ensure => '0.1.0-1.el7',
}
```

#### Parameters

The following parameters are available in the `openondemand::install::app` defined type:

* [`ensure`](#ensure)
* [`package`](#package)
* [`manage_package`](#manage_package)
* [`path`](#path)
* [`owner`](#owner)
* [`group`](#group)
* [`mode`](#mode)

##### <a name="ensure"></a>`ensure`

Data type: `String`

Package ensure property if installing from a package

Default value: `'present'`

##### <a name="package"></a>`package`

Data type: `String`

Package name for the app

Default value: `"ondemand-${name}"`

##### <a name="manage_package"></a>`manage_package`

Data type: `Boolean`

Should package be managed

Default value: ``true``

##### <a name="path"></a>`path`

Data type: `Optional[Stdlib::Absolutepath]`

Path to app, defaults to `/var/www/ood/apps/sys/$name`

Default value: ``undef``

##### <a name="owner"></a>`owner`

Data type: `String`

File owner of app

Default value: `'root'`

##### <a name="group"></a>`group`

Data type: `String`

File group owner of app

Default value: `'root'`

##### <a name="mode"></a>`mode`

Data type: `String`

File mode for app

Default value: `'0755'`

## Data types

### <a name="openondemandacl"></a>`Openondemand::Acl`

OnDemand cluster ACL

Alias of

```puppet
Struct[{ 'adapter' => Enum['group'],
                                  'groups'  => Optional[Array],
                                  'type'    => Enum['whitelist', 'blacklist']
                                  }]
```

### <a name="openondemandbatch_connect"></a>`Openondemand::Batch_connect`

Defines cluster config batch_connect values

Alias of

```puppet
Struct[{
  Optional['basic']     => Struct[{'script_wrapper' => String}],
  Optional['vnc']       => Struct[{'script_wrapper' => String}],
  Optional['ssh_allow'] => Boolean,
}]
```

### <a name="openondemanddashboard_layout"></a>`Openondemand::Dashboard_layout`

Dashboard layout

Alias of

```puppet
Struct[{
  'rows' => Array[Struct[{'columns' => Array[Openondemand::Dashboard_layout_column]}]]
}]
```

### <a name="openondemanddashboard_layout_column"></a>`Openondemand::Dashboard_layout_column`

Dashboard layout column

Alias of

```puppet
Struct[{
  'width' => Integer,
  'widgets' => Array[String[1]],
}]
```

### <a name="openondemanddex_config"></a>`Openondemand::Dex_config`

ondemand-dex config

Alias of

```puppet
Struct[{
  'ssl' => Optional[Boolean],
  'http_port' => Optional[Variant[String, Integer]],
  'https_port' => Optional[Variant[String, Integer]],
  'tls_cert' => Optional[Stdlib::Absolutepath],
  'tls_key' => Optional[Stdlib::Absolutepath],
  'storage_file' => Optional[Stdlib::Absolutepath],
  'grpc' => Optional[Hash],
  'expiry' => Optional[Hash],
  'client_id' => Optional[String],
  'client_redirect_uris' => Optional[Array],
  'client_name' => Optional[String],
  'client_secret' => Optional[String],
  'static_clients' => Optional[Array[Hash]],
  'connectors' => Optional[Array[Hash]],
  'frontend' => Optional[Hash],
  }]
```

### <a name="openondemandk8_auth"></a>`Openondemand::K8_auth`

OnDemand cluster Kubernetes auth

Alias of

```puppet
Struct[{
    'type' => String[1],
  }]
```

### <a name="openondemandk8_mount"></a>`Openondemand::K8_mount`

OnDemand cluster Kubernetes mount

Alias of

```puppet
Struct[{ 'type' => String[1],
    'name'  => String[1],
    'host_type' => Optional[String[1]],
    'host' => Optional[String[1]],
    'destination_path' => Stdlib::Absolutepath,
    'path' => Stdlib::Absolutepath,
  }]
```

### <a name="openondemandk8_server"></a>`Openondemand::K8_server`

OnDemand cluster Kubernetes mount

Alias of

```puppet
Struct[{ 'endpoint' => Stdlib::HTTPSUrl,
    'cert_authority_file'  => Stdlib::Absolutepath,
  }]
```

### <a name="openondemandnginx_stage_namespace_config"></a>`Openondemand::Nginx_stage_namespace_config`

nginx_stage.yml namespace_config

Alias of

```puppet
Struct[{
  'dev' => Optional[String],
  'usr' => Optional[String],
  'sys' => Optional[String]
  }]
```

## Tasks

### <a name="announce"></a>`announce`

Install Open OnDemand announcement file

**Supports noop?** false

#### Parameters

##### `source`

Data type: `String[1]`

Path to file to install (or purge)

### <a name="maintenance"></a>`maintenance`

Put OnDemand into maintenance mode

**Supports noop?** false

#### Parameters

##### `ensure`

Data type: `Enum['present','absent']`

Set state of maintenance mode

### <a name="nginx_stage"></a>`nginx_stage`

Run nginx_stage commands

**Supports noop?** false

#### Parameters

##### `command`

Data type: `Enum[nginx_clean,nginx_list]`

nginx_stage command to execute

##### `user`

Data type: `Optional[String[1]]`

Operate on specific user

##### `skip_nginx`

Data type: `Optional[Boolean]`

Skip execution of the per-user nginx process

##### `force`

Data type: `Optional[Boolean]`

Force clean ALL per-user nginx processes

